unit main;

interface

uses Windows, Classes, SysUtils, Dialogs;

type
  TCommFortProcess = procedure(dwPluginID : DWORD; dID: DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD); stdcall;
  TCommFortGetData = function(dwPluginID : DWORD; dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; stdcall;


function  PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer; cdecl; stdcall;
procedure PluginStop(); cdecl; stdcall;
procedure PluginShowOptions(); cdecl; stdcall;
procedure PluginShowAbout(); cdecl; stdcall;
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD); cdecl; stdcall;
function  PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar;
            dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; cdecl; stdcall;
function  PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD): Integer; cdecl; stdcall;

function  fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer;
function  fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString;
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer);
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString);
function  fTextToAnsiString(uText : WideString) : AnsiString;
function  fIntegerToAnsiString(iValue : Integer) : AnsiString;



exports PluginStart, PluginStop, PluginProcess, PluginGetData, PluginShowOptions, PluginShowAbout, PluginPremoderation;

implementation

var
  dwPluginID : DWORD;
  CommFortProcess : TCommFortProcess;
  CommFortGetData : TCommFortGetData;

//---------------------------------------------------------------------------
function fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer; //       
begin
	CopyMemory(@Result, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
end;

function fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString; //       
 var iLength : Integer;
begin
	CopyMemory(@iLength, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
	SetLength(Result, iLength);
	CopyMemory(@Result[1], bInBuffer + iOffSet, iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer); //       
begin
	CopyMemory(bOutBuffer + iOffSet, @iValue, 4);
	iOffset := iOffset + 4;
end;
//---------------------------------------------------------------------------
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString); //       
	var iLength : Integer;
begin
	iLength := Length(uValue);
	CopyMemory(bOutBuffer + iOffset, @iLength, 4);
	iOffset := iOffset + 4;

	CopyMemory(bOutBuffer + iOffSet, @uValue[1], iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
function fTextToAnsiString(uText : WideString) : AnsiString; //      
	var iLength : Integer;
begin
	//    ,
	//    ,
	//        
	iLength := Length(uText);

	SetLength(Result, 4 + iLength * 2);

	CopyMemory(@Result[1], @iLength, 4);
	CopyMemory(PAnsiChar(Result) + 4, @uText[1], iLength * 2);
end;
//---------------------------------------------------------------------------
function fIntegerToAnsiString(iValue : Integer) : AnsiString; //      
begin
	//    ,
	//    ,
	//        

	SetLength(Result, 4);
	CopyMemory(@Result[1], @iValue, 4);
end;
//---------------------------------------------------------------------------
function PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer;
var aDataToSend, aData : AnsiString;
    iSize, iReadOffset : Integer;
    uVersion : WideString;
begin
	dwPluginID := dwThisPluginID;
	//     
	//   ,  
	//      
	CommFortProcess := func1;
        //   ,
	//      

	CommFortGetData := func2;
        //   ,
	//         


	//  
	aDataToSend := fTextToAnsiString('Repeater')+  //
	 fTextToAnsiString('192.168.0.0')+ //IP-
	 fIntegerToAnsiString(0)+  //   
	 fTextToAnsiString('bkjxzbibe47bed8w7')+   //
	 fIntegerToAnsiString(0); // 

	CommFortProcess(dwPluginID, 1001, PAnsiChar(aDataToSend), Length(aDataToSend));

	//     (  ):
	iSize := CommFortGetData(dwPluginID, 2001, nil, 0, nil, 0); //  
	SetLength(aData, iSize);
	CommFortGetData(dwPluginID, 2001, PAnsiChar(aData), iSize, nil, 0);// 
	iReadOffset := 0;
	uVersion := fReadText(PAnsiChar(aData), iReadOffset);
	ShowMessage('     CommFort  - ' + uVersion);


	// :
	//TRUE -   
	//FALSE -  
	Result := Integer(TRUE);
end;
//---------------------------------------------------------------------------
procedure PluginStop();
begin
	//      
end;
//---------------------------------------------------------------------------
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset, iSenderIcon, iMessageMode : Integer;
    aDataToSend : AnsiString;
    uVirtualUserLogin, uSenderLogin, uSenderIP, uChannel, uText : WideString;

begin
	//  
	//:
	//dwID -  
	//bInBuffer -   
	//dwInBufferSize -    
	iReadOffset := 0;

	if (dwID = 1070) then //   
	begin
		//   
 		uVirtualUserLogin := fReadText(bInBuffer, iReadOffset);
		uSenderLogin := fReadText(bInBuffer, iReadOffset);
		uSenderIP := fReadText(bInBuffer, iReadOffset);
		iSenderIcon := fReadInteger(bInBuffer, iReadOffset);
		uChannel := fReadText(bInBuffer, iReadOffset);
		iMessageMode := fReadInteger(bInBuffer, iReadOffset);
		uText := fReadText(bInBuffer, iReadOffset);

		//  
		aDataToSend := fTextToAnsiString('Repeater')+  //  
		 fIntegerToAnsiString(0)+  // 
  		 fTextToAnsiString(uSenderLogin)+
	  	 fTextToAnsiString(uText); //
  		 CommFortProcess(dwPluginID, 1022, PAnsiChar(aDataToSend), Length(aDataToSend))
	end;
end;
//---------------------------------------------------------------------------
function PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;
var iWriteOffset, iSize : Integer; //       
    uName : WideString;
begin

      //   
	iWriteOffset := 0;

	//  dwOutBufferSize       ,   

	if (dwID = 2800) then // 
	begin
		if (dwOutBufferSize = 0) then
			Result := 4 //   ,    
		else
		begin
			fWriteInteger(bOutBuffer, iWriteOffset, 1); //    
			Result := 4;//    
		end;
	end
	else
	if (dwID = 2810) then //  (  )
	begin
		uName := 'Repeater ( )';// 
		iSize := Length(uName) * 2 + 4;

		if (dwOutBufferSize = 0) then
			Result := iSize //   ,    
		else
		begin
			fWriteText(bOutBuffer, iWriteOffset, uName);
			Result := iSize;//    
		end;
	end
	else
		Result := 0;//  -   
end;
//---------------------------------------------------------------------------
function PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD):  Integer;
var uCheck, uRet : WideString;
begin
	// 
        //     ,      ,    

	//!    40000 .       .
	if (dwID = 1000) then//     
	begin
		uCheck := '    ';

		// Delphi  2009       //if  ( StrComp(PAnsiChar(wText), PAnsiChar(uCheck)) = 0) then
	 	if ( StrComp(wText, PWideChar(uCheck)) = 0) then
		begin
			uRet := '    : ';
			CopyMemory(wText, @uRet[1], Length(uRet) * 2);
			dwTextLength := Length(uRet);//  
			Result := Integer(TRUE);//TRUE     
		end
		else
			Result := Integer(FALSE);
	end
	else
		Result := Integer(FALSE);//  FALSE       
end;
//---------------------------------------------------------------------------
procedure PluginShowOptions();
begin
	ShowMessage('Options dialog');
end;

//---------------------------------------------------------------------------
procedure PluginShowAbout();
begin
	//      " "   
	ShowMessage('        .'
	 + #13#10 + 'Created by CommFort software Ltd.'
	 + #13#10 + 'Converted to Delphi by -=SJ=-'
	);
end;

end.
